package cz.sa.shiftPlanner.auth;

import java.util.Collection;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.AccessDecisionVoter;
import org.springframework.security.access.ConfigAttribute;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.GrantedAuthority;


public class RoleVoter implements AccessDecisionVoter<Object> {

	@Autowired
	private UserRoleCollection collection;

	
	@Override
	public boolean supports(ConfigAttribute attribute) {
		return true;
	}

	@Override
	public boolean supports(Class clazz) {
		return true;
	}

	@Override
	public int vote(Authentication authentication, Object object, Collection<ConfigAttribute> attributes) {
		 int result = ACCESS_ABSTAIN;
		 Collection<GrantedAuthority> authorities = (Collection<GrantedAuthority>)authentication.getAuthorities();
		 for (ConfigAttribute attribute : attributes) {
			 for(GrantedAuthority authority : authorities) {
				 if(collection.checkRoleHierarchy(authority.getAuthority(),attribute.getAttribute())) {
					 result = ACCESS_GRANTED;
					 break;
				 }
			 }
		 }
		 return result;
	}
	

}
