package cz.sa.shiftPlanner.dao;

import java.util.List;

import cz.sa.shiftPlanner.entities.CityVO;
import cz.sa.shiftPlanner.entities.StationVO;

public interface CityDAO {
		/**
	     * gets City by its id
	     * @param id
	     * @throws IllegalArgumentException when argument null
	     * @return City or NULL when not found
	     */
	    CityVO get(Long id);
	    
	    /**
	     * Persists city
	     * this entity must be ID manually set before call save()
	     * @throws ArgumentException id==null
	     * @throws IllegalArgumentException when argument null
	     * @param city
	     */
	    void create(CityVO city);

	    /**
	     * Updates city
	     * @throws ArgumentException when city is not persisted
	     * @throws IllegalArgumentException when argument null
	     * @param city 
	     */
	    void update(CityVO city);

	    /**
	     * Removes persisted city
	     * @throws ArgumentException when city is not persisted
	     * @throws IllegalArgumentException when argument null
	     * @param city 
	     */
	    void remove(CityVO city);

	    /**
	     * Retrieves all city from source
	     * @return 
	     */
	    List<CityVO> findAll();

	    List<CityVO> findByName(String name);
	    
	    List<CityVO> findByCityId(Long id);

		void save(CityVO c);

    void createStation(StationVO newSt);

    StationVO getStation(Long stationId);

    List<CityVO> findAllCZ();
    
    List<StationVO> findAllStations();

}
