package cz.sa.shiftPlanner.dao;

import java.util.List;

import cz.sa.shiftPlanner.entities.LineGroupVO;
import cz.sa.shiftPlanner.entities.LineVO;

public interface LineGroupDAO {
	/**
     * gets Line by its id
     * @param id
     * @throws IllegalArgumentException when argument null
     * @return line or NULL when not found
     */
	LineGroupVO get(Long id);

    /**
     * Updates line
     * @throws ArgumentException when line is not persisted
     * @throws IllegalArgumentException when argument null
     * @param line 
     */
    void update(LineGroupVO line);

    /**
     * Removes persisted line
     * @throws ArgumentException when line is not persisted
     * @throws IllegalArgumentException when argument null
     * @param line 
     */
    void remove(LineGroupVO line);

    /**
     * Retrieves all lines from source
     * @return 
     */
    List<LineGroupVO> findAll();

	void save(LineGroupVO lLoc);

  LineVO getLine(Long id);

  void saveLine(LineVO line);
}
