package cz.sa.shiftPlanner.dao;

import java.util.List;

import org.joda.time.DateTime;

import cz.sa.shiftPlanner.entities.PersonVO;
import cz.sa.shiftPlanner.entities.WayVO;
import cz.sa.shiftPlanner.entities.WayVOAudit;

public interface WayDAO {
	/**
     * gets Way by its id
     * @param id
     * @throws IllegalArgumentException when argument null
     * @return way or NULL when not found
     */
    WayVO get(Long id);
    
    /**
     * Persists way
     * 
     * Note!
     * set attribute isActive to TRUE value
     * 
     * @throws ArgumentException when way is already persisted
     * @throws IllegalArgumentException when argument null
     * @param way
     */
    void create(WayVO way);

    /**
     * Updates way
     * @throws ArgumentException when way is not persisted
     * @throws IllegalArgumentException when argument null
     * @param way 
     */
    void update(WayVO way);

    /**
     * Removes persisted way
     * @throws ArgumentException when way is not persisted
     * @throws IllegalArgumentException when argument null
     * @param way 
     */
    void remove(WayVO way);

    /**
     * Retrieves all way from source
     * @return 
     */
    List<WayVO> findAll();
    
    List<WayVO> findByTimeRange(DateTime from, DateTime to, PersonVO p);
    
    List<WayVO> findByMonth(DateTime from, DateTime to, PersonVO p);

	List<WayVO> findByDepRange(DateTime from, DateTime to, PersonVO p);

  List<WayVOAudit> findByMonthNonActive(DateTime from, DateTime to, PersonVO p);

  void createAuditVO(WayVOAudit auditVO);

}
