package cz.sa.shiftPlanner.daoImpl;


import org.springframework.stereotype.Repository;

import cz.sa.shiftPlanner.dao.TimeCodeDAO;
import cz.sa.shiftPlanner.entities.SymbolVO;
import cz.sa.shiftPlanner.entities.TimeCodeVO;
import cz.sa.shiftPlanner.infrastructure.dao.AbstractDao;

/**
 * @author ToSk
 */

@Repository
public class TimeCodeDAOImpl extends AbstractDao implements TimeCodeDAO {

	@Override
	public TimeCodeVO get(Long id) {
		if(id == null) return null;
		
		return (TimeCodeVO) getSession().get(TimeCodeVO.class, id);
	}

	@Override
	public SymbolVO getSymbol(Long id) {
		
		return (SymbolVO)getSession().createQuery("select s from SymbolVO as s where s.id=:id").setParameter("id", id).uniqueResult();
	}

	@Override
	public void save(TimeCodeVO code) {
			getSession().save(code);
	}

	@Override
	public void update(TimeCodeVO code) {
		
		getSession().update(code);
	}

}


