package cz.sa.shiftPlanner.dto;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;

import org.hibernate.annotations.Type;
import org.joda.time.DateTime;

import com.google.common.collect.Lists;

import cz.sa.shiftPlanner.entities.BusConnectionVO;
import cz.sa.shiftPlanner.entities.BusTimetableVO;
import cz.sa.shiftPlanner.entities.WayVO;
import cz.sa.shiftPlanner.entities.infrastructure.AbstractVO;


public class BusConnectionDTO extends AbstractVO {
	
	private BusConnectionDTO supportFor;

	private List<BusConnectionDTO> supports = Lists.newArrayList();
	
	private DateTime arrivalTime;
	
	private DateTime departureTime;

	private BusTimetableDTO timetable;
	
	private String note;
	
	private String standard;
	
	private List<WayDTO> ways = new ArrayList<WayDTO>();

	private boolean clearance;
	
	private BusTurnsTimetableDTO busTurn;
	
	
	public BusTurnsTimetableDTO getBusTurn() {
    return busTurn;
  }

  public void setBusTurn(BusTurnsTimetableDTO busTurn) {
    this.busTurn = busTurn;
  }

  public boolean isClearance() {
		return clearance;
	}

	public void setClearance(boolean clearance) {
		this.clearance = clearance;
	}

	public String getStandard() {
		return standard;
	}

	public void setStandard(String standard) {
		this.standard = standard;
	}

	public String getNote() {
		return note;
	}

	public void setNote(String note) {
		this.note = note;
	}

	public BusConnectionDTO getSupportFor() {
		return supportFor;
	}

	public void setSupportFor(BusConnectionDTO supportFor) {
		this.supportFor = supportFor;
	}

	public List<BusConnectionDTO> getSupports() {
		return supports;
	}

	public void setSupports(List<BusConnectionDTO> supports) {
		this.supports = supports;
	}

	public DateTime getArrivalTime() {
		return arrivalTime;
	}

	public void setArrivalTime(DateTime arrivalTime) {
		this.arrivalTime = arrivalTime;
	}

	public DateTime getDepartureTime() {
		return departureTime;
	}

	public void setDepartureTime(DateTime departureTime) {
		this.departureTime = departureTime;
	}

	public BusTimetableDTO getTimetable() {
		return timetable;
	}

	public void setTimetable(BusTimetableDTO timetable) {
		this.timetable = timetable;
	}

	public List<WayDTO> getWays() {
		return ways;
	}

	public void setWays(List<WayDTO> ways) {
		this.ways = ways;
	}

	
	
}
