package cz.sa.shiftPlanner.entities;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;
import org.hibernate.annotations.Type;
import org.joda.time.DateTime;

import com.google.common.collect.Lists;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractNoGenVO;


@Entity
@Table(name = "bus_connection")
public class BusConnectionVO extends AbstractNoGenVO {
	
	@ManyToOne(fetch = FetchType.LAZY, optional=true)
	private BusConnectionVO supportFor;

	@OneToMany(mappedBy = "supportFor")
	private List<BusConnectionVO> supports = Lists.newArrayList();
	
	@Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
	@Column(nullable=false)
	private DateTime arrivalTime;
	
	@Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
	@Column(nullable=false)
	private DateTime departureTime;

	
	@ManyToOne(cascade = CascadeType.DETACH, fetch=FetchType.EAGER)
	@NotFound(action=NotFoundAction.EXCEPTION)
	private BusTimetableVO timetable;
	
	@Column(nullable=true)
	private String note;
	
	@Column(nullable=true)
	private String standard;
	
	@OneToMany( mappedBy = "connection", cascade = CascadeType.DETACH)
	private List<WayVO> ways = new ArrayList<WayVO>();

	
	public String getStandard() {
		return standard;
	}

	public void setStandard(String standard) {
		this.standard = standard;
	}

	public String getNote() {
		return note;
	}

	public void setNote(String note) {
		this.note = note;
	}

	public BusConnectionVO getSupportFor() {
		return supportFor;
	}

	public void setSupportFor(BusConnectionVO supportFor) {
		this.supportFor = supportFor;
	}

	public List<BusConnectionVO> getSupports() {
		return supports;
	}

	public void setSupports(List<BusConnectionVO> supports) {
		this.supports = supports;
	}

	public DateTime getArrivalTime() {
		return arrivalTime;
	}

	public void setArrivalTime(DateTime arrivalTime) {
		this.arrivalTime = arrivalTime;
	}

	public DateTime getDepartureTime() {
		return departureTime;
	}

	public void setDepartureTime(DateTime departureTime) {
		this.departureTime = departureTime;
	}

	public BusTimetableVO getTimetable() {
		return timetable;
	}

	public void setTimetable(BusTimetableVO timetable) {
		this.timetable = timetable;
	}

	public List<WayVO> getWays() {
		return ways;
	}

	public void setWays(List<WayVO> ways) {
		this.ways = ways;
	}

	
	

	
	
}
