package cz.sa.shiftPlanner.entities;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToMany;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractNoGenVO;
import cz.sa.shiftPlanner.entities.infrastructure.AbstractVO;

@Entity(name = "CityVO")
@Table(name = "city")
public class CityVO extends AbstractNoGenVO{
	
	public CityVO() {
	}
	
	@Column(columnDefinition="varchar(50)", nullable=false)
	private String cityName;

	
	@Column(columnDefinition="varchar(20)", nullable=true)
	private String country;
	
	@OneToMany(mappedBy = "city")
	private List<StationVO> stations;
	
	@ManyToMany(mappedBy = "city", targetEntity = PersonVO.class)
	private List<PersonVO> persons = new ArrayList<PersonVO>();
	

	public List<PersonVO> getPersons() {
    return persons;
  }

  public void setPersons(List<PersonVO> persons) {
    this.persons = persons;
  }

  public String getCityName() {
		return cityName;
	}

	public void setCityName(String cityName) {
		this.cityName = cityName;
	}

	public List<StationVO> getStations() {
    return stations;
  }

  public void setStations(List<StationVO> stations) {
    this.stations = stations;
  }

  public String getCountry() {
		return country;
	}

	public void setCountry(String country) {
		this.country = country;
	}

	@Override
	public String toString() {
		return "CityVO [name=" + cityName + ", country=" + country + "]";
	}

	
	
}
