package cz.sa.shiftPlanner.entities;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.Type;
import org.joda.time.DateTime;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractVO;
import cz.sa.shiftPlanner.enums.ExcuseReason;
import cz.sa.shiftPlanner.enums.ExcuseStatus;

/**
 * @author ToSk
 */

@Entity
@Table(name = "excuse")
public class ExcuseVO extends AbstractVO{
	
	@ManyToOne(fetch = FetchType.LAZY)
	private PersonVO person;
	 
	@Column(name="reason") 
	@Enumerated(EnumType.STRING)
	private ExcuseReason reason;
	
	@Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
	private DateTime from_;

	@Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
	private DateTime to_;
	
	@Column
	private String excuseText;
	
	@Column(name="status") 
  @Enumerated(EnumType.STRING)
	private ExcuseStatus status;

	public ExcuseStatus getStatus() {
    return status;
  }

  public void setStatus(ExcuseStatus status) {
    this.status = status;
  }

  public PersonVO getPerson() {
		return person;
	}

	public void setPerson(PersonVO person) {
		this.person = person;
	}

	public ExcuseReason getReason() {
		return reason;
	}

	public void setReason(ExcuseReason reason) {
		this.reason = reason;
	}

	public DateTime getFrom_() {
		return from_;
	}

	public void setFrom_(DateTime from_) {
		this.from_ = from_;
	}

	public DateTime getTo_() {
		return to_;
	}

	public void setTo_(DateTime to_) {
		this.to_ = to_;
	}

	public String getExcuseText() {
		return excuseText;
	}

	public void setExcuseText(String excuseText) {
		this.excuseText = excuseText;
	}
	
	
	
}


