package cz.sa.shiftPlanner.entities;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.Type;
import org.joda.time.DateTime;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractNoGenVO;
import cz.sa.shiftPlanner.enums.LineType;
import cz.sa.shiftPlanner.enums.NotifType;

/**
 *
 * @author    ToSk
 * @version   1.0
 * @created   12. 11. 2013
 */

@Entity
@Table(name = "line")
public class LineVO extends AbstractNoGenVO {

  @ManyToOne(cascade = CascadeType.DETACH)
  @JoinColumn(name="linegroup_id") 
  private LineGroupVO lineGroup;
  
  @Column
  private String name;
  
  @Column
  @Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
  private DateTime validFrom;
  
  @Column
  @Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
  private DateTime validTo;
  
  @Column(name="linetype") 
  @Enumerated(EnumType.STRING)
  private LineType lineType;
  
  @ManyToMany(mappedBy = "line", targetEntity = PersonVO.class)
  private List<PersonVO> persons = new ArrayList<PersonVO>();

  public LineGroupVO getLineGroup() {
    return lineGroup;
  }

  public void setLineGroup(LineGroupVO lineGroup) {
    this.lineGroup = lineGroup;
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public DateTime getValidFrom() {
    return validFrom;
  }

  public void setValidFrom(DateTime validFrom) {
    this.validFrom = validFrom;
  }

  public DateTime getValidTo() {
    return validTo;
  }

  public void setValidTo(DateTime validTo) {
    this.validTo = validTo;
  }

  public LineType getLineType() {
    return lineType;
  }

  public void setLineType(LineType lineType) {
    this.lineType = lineType;
  }

  public List<PersonVO> getPersons() {
    return persons;
  }

  public void setPersons(List<PersonVO> persons) {
    this.persons = persons;
  }
  
  
}
