package cz.sa.shiftPlanner.entities;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import org.hibernate.annotations.Type;
import org.joda.time.DateTime;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractVO;
import cz.sa.shiftPlanner.enums.NotifType;

@Entity
@Table(name = "notification")
public class NotificationVO extends AbstractVO{

	@Column
	private String text;
	
	@Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
	private DateTime created;
	
	@OneToOne
	private PersonVO person;
	
	@Column
	private boolean isReaded;
	
	@Column(name="notifType") 
	@Enumerated(EnumType.STRING)
	private NotifType notifType;

	
	public NotifType getNotifType() {
		return notifType;
	}

	public void setNotifType(NotifType notifType) {
		this.notifType = notifType;
	}

	public String getText() {
		return text;
	}

	public void setText(String text) {
		this.text = text;
	}

	public DateTime getCreated() {
		return created;
	}

	public void setCreated(DateTime created) {
		this.created = created;
	}

	public PersonVO getPerson() {
		return person;
	}

	public void setPerson(PersonVO person) {
		this.person = person;
	}

	public boolean isReaded() {
		return isReaded;
	}

	public void setReaded(boolean isReaded) {
		this.isReaded = isReaded;
	}

	
}
