package cz.sa.shiftPlanner.entities;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.Type;
import org.joda.time.DateTime;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractVO;

/**
 * @author ToSk
 */

@Entity
@Table(name = "time_trial")
public class TimeTrialVO extends AbstractVO {

	@ManyToOne(fetch = FetchType.LAZY)
	private PersonVO person;
	
	@Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
	private DateTime from_;

	@Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
	private DateTime to_;
	
	@Column
	private String note;

	public PersonVO getPerson() {
		return person;
	}

	public void setPerson(PersonVO person) {
		this.person = person;
	}

	public DateTime getFrom_() {
		return from_;
	}

	public void setFrom_(DateTime from_) {
		this.from_ = from_;
	}

	public DateTime getTo_() {
		return to_;
	}

	public void setTo_(DateTime to_) {
		this.to_ = to_;
	}

	public String getNote() {
		return note;
	}

	public void setNote(String note) {
		this.note = note;
	}

	
}


