package cz.sa.shiftPlanner.entities;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.ManyToOne;
import javax.persistence.MappedSuperclass;

import org.hibernate.annotations.Type;
import org.joda.time.DateTime;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractVO;

/**
 *
 * @author    ToSk
 * @version   1.0
 * @created   11. 11. 2013
 */

@MappedSuperclass
public abstract class Way extends AbstractVO{

  @ManyToOne(cascade = CascadeType.DETACH)
  private PersonVO person;
  
  @ManyToOne(cascade = CascadeType.DETACH)
  private StationVO arrivalStation;
  
  @ManyToOne(cascade = CascadeType.DETACH)
  private StationVO departureStation;
  
  @Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
  @Column(nullable=true)
  private DateTime arrivalTime;
  
  @Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
  @Column(nullable=true)
  private DateTime departureTime;
  
  @Column(nullable=false)
  private int delay;
  
  @Column(nullable=false)
  private Boolean isForeign;
  
  @Column(nullable=true)
  private String note;

  @Column(nullable=false)
  private boolean isCheckIn;
  
  
  public boolean isCheckIn() {
    return isCheckIn;
  }

  public void setCheckIn(boolean isCheckIn) {
    this.isCheckIn = isCheckIn;
  }

  public String getNote() {
    return note;
  }

  public void setNote(String note) {
    this.note = note;
  }

  public PersonVO getPerson() {
    return person;
  }

  public void setPerson(PersonVO person) {
    this.person = person;
  }

  public int getDelay() {
    return delay;
  }

  public void setDelay(int delay) {
    this.delay = delay;
  }

  public Boolean getIsForeign() {
    return isForeign;
  }

  public void setIsForeign(Boolean isForeign) {
    this.isForeign = isForeign;
  }


  public StationVO getArrivalStation() {
    return arrivalStation;
  }

  public void setArrivalStation(StationVO arrivalStation) {
    this.arrivalStation = arrivalStation;
  }

  public StationVO getDepartureStation() {
    return departureStation;
  }

  public void setDepartureStation(StationVO departureStation) {
    this.departureStation = departureStation;
  }

  public DateTime getArrivalTime() {
    return arrivalTime;
  }

  public void setArrivalTime(DateTime arrivalTime) {
    this.arrivalTime = arrivalTime;
  }

  public DateTime getDepartureTime() {
    return departureTime;
  }

  public void setDepartureTime(DateTime departureTime) {
    this.departureTime = departureTime;
  }
}
