package cz.sa.shiftPlanner.entities;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import cz.sa.shiftPlanner.entities.infrastructure.AbstractVO;

/**
 * @author ToSk
 */

@Entity
@Table(name="work_hours")
public class WorkHoursVO extends AbstractVO{
	
	@Column
	private int month;
	
	@Column
	private int year;
	
	@Column
	private int hoursNorm;
	
	@Column
	private Integer monthAmount;
	
	@ManyToOne(fetch = FetchType.LAZY)
	private PersonVO person;
	
	@OneToMany(mappedBy = "workHours", cascade=CascadeType.REMOVE)
	List<WorkHoursItemVO> items = new ArrayList<WorkHoursItemVO>();

	
	public int getMonthAmount() {
		return monthAmount;
	}

	public void setMonthAmount(int monthAmount) {
		this.monthAmount = monthAmount;
	}

	public int getHoursNorm() {
		return hoursNorm;
	}

	public void setHoursNorm(int hoursNorm) {
		this.hoursNorm = hoursNorm;
	}

	public int getMonth() {
		return month;
	}

	public void setMonth(int month) {
		this.month = month;
	}

	public int getYear() {
		return year;
	}

	public void setYear(int year) {
		this.year = year;
	}

	public PersonVO getPerson() {
		return person;
	}

	public void setPerson(PersonVO person) {
		this.person = person;
	}

	public List<WorkHoursItemVO> getItems() {
		return items;
	}

	public void setItems(List<WorkHoursItemVO> items) {
		this.items = items;
	}

	
	

}