package cz.sa.shiftPlanner.entities.infrastructure;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;
import javax.persistence.SequenceGenerator;

import org.hibernate.annotations.Type;
import org.joda.time.DateTime;


/**
 * @author ToSk
 */
@MappedSuperclass
public abstract class AbstractVO implements Serializable {

	public static final int BATCH_SIZE = 100;

	@Id
	@GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "idSequenceGenerator")
	@SequenceGenerator(name = "idSequenceGenerator", sequenceName = "ID_GEN", allocationSize = 10)
	private Long id;
	
	public Long getId() {
		return id;
	}
	
	public void setId(Long id) {
		this.id = id;
	}


	/**
	 * Obsahuje APLIKACNI cas vytvoreni. Tj. cas z aplikacniho serveru
	 * 
	 * @see #dbDateCreated
	 */
	@Type(type = "org.jadira.usertype.dateandtime.joda.PersistentDateTime")
	@Column(nullable = true)
	private DateTime dateCreated;


	public DateTime getDateCreated() {
	  return dateCreated;
	}
	
	public void setDateCreated(DateTime dateCreated) {
	  this.dateCreated = dateCreated;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}


  @Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AbstractVO other = (AbstractVO) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}

}
