package cz.sa.shiftPlanner.entities.infrastructure;

import java.io.Serializable;
import java.util.Map;

import org.hibernate.EmptyInterceptor;
import org.hibernate.SessionFactory;
import org.hibernate.type.Type;
import org.joda.time.DateTime;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;

import com.google.common.collect.Iterables;

import cz.sa.shiftPlanner.entities.WayVO;


public class HibernateEntityInterceptor extends EmptyInterceptor implements ApplicationContextAware {

  private ApplicationContext applicationContext;
  private SessionFactory sessionFactory;
  
  
  /**
   * Inicializace kruhovych zavislosti
   */
  public void init() {
    Map<?, ?> sessionFactories = applicationContext.getBeansOfType(SessionFactory.class);
    sessionFactory = (SessionFactory) Iterables.getOnlyElement(sessionFactories.values());
  }

  @Override
  public boolean onSave(Object entity, Serializable id, Object[] state, String[] propertyNames, Type[] types) {
    if (entity instanceof AbstractVO || entity instanceof AbstractNoGenVO) {
      Object oldDateCreated = state[arrayIndexOf(propertyNames, "dateCreated")];
      if (oldDateCreated == null) {
        state[arrayIndexOf(propertyNames, "dateCreated")] = new DateTime();
      }
      return true;
    }
    return false;
  }

 

  private int arrayIndexOf(Object[] array, Object value) {
    for (int i = 0; i < array.length; i++) {
      if (array[i].equals(value)) {
        return i;
      }
    }
    return -1;
  }

  public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
    this.applicationContext = applicationContext;
  }


}
