package cz.sa.shiftPlanner.enums;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * 
 * @author ToSk
 * @version 1.0
 * @created 6. 10. 2013
 */

public enum UserRoleHierarchy {

  Helplinka(null),
  Steward(null),
    Coordinator(Steward),
      Supervisor(Coordinator);
  
  private UserRoleHierarchy parent = null;
  private List<UserRoleHierarchy> children = new ArrayList<UserRoleHierarchy>();
  
  private UserRoleHierarchy(UserRoleHierarchy parent){
    this.parent = parent;
    if(this.parent != null)
      //do rodice pridam sebe
      this.parent.children.add(this);
  }
  
  public boolean is(UserRoleHierarchy role){
    if(role == null)
      return false;
    
    for(UserRoleHierarchy t = this; t != null; t = t.parent){
      if(role == t)
        return true;
    }
    return false;
  }
  
  public List<UserRoleHierarchy> getChildren(){
    return Collections.unmodifiableList(children);
  }
  
}
