package cz.sa.shiftPlanner.helios.api;

import java.net.URL;
import java.util.List;
import java.util.Map;

import javax.xml.namespace.QName;
import javax.xml.ws.BindingProvider;
import javax.xml.ws.handler.Handler;
import javax.xml.ws.handler.HandlerResolver;
import javax.xml.ws.handler.PortInfo;

import org.springframework.stereotype.Service;

import com.google.common.collect.Lists;

import cz.sa.helios.api.HeliosAPI;
import cz.sa.helios.api.HeliosAPISoap;

/**
 * @author ToSk
 */

@Service
public class HeliosApiService {
  
  private HeliosAPI service;
  
  public HeliosAPISoap getSoap() {
    HeliosAPISoap port = getService().getHeliosAPISoap12();
    addPortProperties((BindingProvider) port);
    return port;
  }
  
  private HeliosAPI getService() {
    if(service == null) {
      URL resource = HeliosAPI.class.getResource("HeliosAPIWebService.wsdl");
      service = new HeliosAPI(resource, new QName("http://heliosapi.sa.cz/", "HeliosAPI"));
      service.setHandlerResolver(new HandlerChainProvider());
    }
    return service;
  }
  
  private void addPortProperties(BindingProvider provider) {
    final Map<String, Object> requestContext = provider.getRequestContext();
    requestContext.put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY, "http://heliosapi.sa.cz/21/HeliosAPIWebService.asmx");
  }
  

  private final class HandlerChainProvider implements HandlerResolver {

	    public HandlerChainProvider() {
	    }

	    @SuppressWarnings("unchecked")
	    @Override
	    public List<Handler> getHandlerChain(PortInfo portInfo) {
	        final List<Handler> handlers = Lists.newArrayList();

	        return handlers;
	    }

	}
}
