package cz.sa.shiftPlanner.lifecycle;

import org.slf4j.bridge.SLF4JBridgeHandler;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.context.event.ContextClosedEvent;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.scheduling.quartz.SchedulerFactoryBean;

/**
 * @author ToSk
 */

public class ApplicationContextInitializer implements ApplicationListener<ApplicationEvent> {

//	@Autowired
//	private SchedulerFactoryBean schedulerFactoryBean;

	private boolean initialized = false;

	@Override
	public void onApplicationEvent(ApplicationEvent event) {

		try {
			synchronized (this) { // TLS
				if (event instanceof ContextRefreshedEvent) {
					if (!initialized) {
						// inicializujeme pouze jednou - CXF posila
						// ContextRefreshedEvent pri sve inicializaci
						init();
						initialized = true;
					}
				} else if (event instanceof ContextClosedEvent) {
					destroy();
				}
			}
		} finally {}
	}

	private void init() {
		// start scheduler
//		schedulerFactoryBean.start();
	}

	private void destroy() {
		SLF4JBridgeHandler.uninstall();
	}
}
