package cz.sa.shiftPlanner.main;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;

import org.apache.commons.io.FileUtils;
import org.joda.time.DateTime;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import cz.sa.shiftPlanner.dao.PersonUtilsDAO;
import cz.sa.shiftPlanner.dto.BusConnectionDTO;
import cz.sa.shiftPlanner.dto.WayDTO;
import cz.sa.shiftPlanner.entities.LineGroupVO;
import cz.sa.shiftPlanner.entities.PersonRecordVO;
import cz.sa.shiftPlanner.entities.PersonVO;
import cz.sa.shiftPlanner.enums.MeasurementType;
import cz.sa.shiftPlanner.enums.Unit;
import cz.sa.shiftPlanner.services.BusConnectionService;
import cz.sa.shiftPlanner.services.PersonService;
import cz.sa.shiftPlanner.services.PersonUtilsService;
import cz.sa.shiftPlanner.services.WayService;
import cz.sa.shiftPlanner.servicesImpl.BusConnectionServiceImpl;
import cz.sa.shiftPlanner.servicesImpl.WayGenerator;
import cz.sa.shiftPlanner.utils.Quantity;
import cz.sa.shiftPlanner.utils.ServiceNoticeException;
import cz.sa.shiftPlanner.ybus.sync.YbusSyncPlan;
import cz.sa.shiftPlanner.ybus.sync.YbusSyncPlanInterf;
import jxl.*;
import jxl.write.Label;
import jxl.write.Number;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import jxl.write.WriteException;
import jxl.write.biff.RowsExceededException;


import java.util.ArrayList;
import java.util.List;

import org.openqa.selenium.*;
import org.openqa.selenium.firefox.FirefoxDriver;
import org.openqa.selenium.htmlunit.HtmlUnitDriver;
import org.openqa.selenium.remote.Augmenter;
import org.openqa.selenium.remote.CommandExecutor;
import org.openqa.selenium.remote.DesiredCapabilities;
import org.openqa.selenium.remote.RemoteWebDriver;

import com.thoughtworks.selenium.*;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.*;

import java.util.regex.Pattern;


@Component
@Transactional
public class Main{

	public static void main(String[] args) {
	
//		ApplicationContext ctx = new ClassPathXmlApplicationContext("applicationContext.xml");
//		WayGenerator wayGenerator = (WayGenerator)ctx.getBean("wayGenerator");
//		try {
//			wayGenerator.generateWay(new DateTime(), new DateTime().plusMonths(1));
//		} catch (ServiceNoticeException e) {
//		}
	  
//		System.out.println("konec generovani");

		
		ApplicationContext ctx = new ClassPathXmlApplicationContext("applicationContext.xml");
//		YbusSyncPlanInterf plan = (YbusSyncPlanInterf)ctx.getBean("ybusSyncPlan");
//		plan.runPlan();
//		BusConnectionService ser = (BusConnectionService)ctx.getBean("busConnectionService");
//		for(BusConnectionDTO w : ser.findConnectionByTime(new DateTime().minusHours(11), new DateTime().plusDays(4).plusHours(12))){
//		  System.out.println("start");
//		  //jen pro BRNO-PRAHA
//		  if(w.getTimetable().getLine().getId().equals(93701000L)){
//  		  w.setArrivalTime(w.getArrivalTime().plusHours(1));
//  		  w.setDepartureTime(w.getDepartureTime().plusHours(1));
//  		  ser.update(w);
//		  }
//		}
		
//		PersonService pservice = (PersonService)ctx.getBean("personService");
//		pservice.downloadStewardsFromHelios();
		
		
//		generateCsvFile("test.csv"); 
//	    try {
//        TimesheetDemo.print();
//      }
//      catch (Exception e) {
//        // TODO Auto-generated catch block
//        e.printStackTrace();
//      }
		
//		testingSelenium();
	}
	
	private static void testingSelenium() {
		DesiredCapabilities capabilities = new DesiredCapabilities();
		capabilities.setBrowserName("firefox");
		CommandExecutor executor = null;
		try {
			executor = new SeleneseCommandExecutor(new URL("http://localhost:4444/"), new URL("http://www.google.com/"), capabilities);
		} catch (MalformedURLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		WebDriver driver = new RemoteWebDriver(executor, capabilities);
		
        driver.get("http://jizdenky.sa.cz");

        WebElement select = driver.findElement(By.xpath("//select"));
        List<WebElement> allOptions = select.findElements(By.tagName("option"));
        for (WebElement option : allOptions) {
            System.out.println(String.format("Value is: %s", option.getAttribute("value")));
        }
        
          
//        WebElement element = driver.findElement(By.name("q"));
//        element.sendKeys("Cheese!");
//        element.submit();
//        System.out.println("Page title is: " + driver.getTitle());
	}
	
	
	
	private static void generateCsvFile(String sFileName)
	   {
			try
			{
			    FileWriter writer = new FileWriter(sFileName);
		 
			    writer.append("DisplayName");
			    writer.append(',');
			    writer.append("Age");
			    writer.append('\n');
		 
			    writer.append("MKYONG");
			    writer.append(',');
			    writer.append("26");
		            writer.append('\n');
		 
			    writer.append("YOUR NAME");
			    writer.append(',');
			    writer.append("29");
			    writer.append('\n');
		 
			    //generate whatever data you want
		 
			    writer.flush();
			    writer.close();
			}
			catch(IOException e)
			{
			     e.printStackTrace();
			} 
	    }
	

	private static void testovani() throws IOException, RowsExceededException, WriteException{
		
		WritableWorkbook workbook = null;
		workbook = Workbook.createWorkbook(new File("output.xls"));
		WritableSheet sheet = workbook.createSheet("First Sheet", 0);
		
		Label label = new Label(0, 2, "A label record"); 
		sheet.addCell(label); 
		
		Number number = new Number(0, 3, 3.56498);
		sheet.addCell(number); 

		Cell cell = sheet.getCell("A3");
		System.out.println(cell.getContents());
		workbook.write(); 
		workbook.close();
		
		System.out.println("end testing method");
	}
	

	
	
	private static void url() throws IOException{
		URL url = new URL("http://www.bank-holidays.com/publicholidays_2013_143.htm");

        // Get the input stream through URL Connection
        URLConnection con = url.openConnection();
        InputStream is =con.getInputStream();

        // Once you have the Input Stream, it's just plain old Java IO stuff.

        // For this case, since you are interested in getting plain-text web page
        // I'll use a reader and output the text content to System.out.

        // For binary content, it's better to directly read the bytes from stream and write
        // to the target file.
        

        BufferedReader br = new BufferedReader(new InputStreamReader(is));

        String line = null;

        // read each line and write to System.out
        while ((line = br.readLine()) != null) {
            System.out.println(line);
            System.out.println("...........");
        }
	}

}
