package cz.sa.shiftPlanner.services;

import java.util.List;

import org.joda.time.DateTime;

import cz.sa.shiftPlanner.dto.BusConnectionDTO;
import cz.sa.shiftPlanner.dto.LineGroupDTO;
import cz.sa.shiftPlanner.dto.StationDTO;
import cz.sa.shiftPlanner.utils.TimeRange;

public interface BusConnectionService {

	BusConnectionDTO get(Long id);
    
    void create(BusConnectionDTO connection);
    
    void update(BusConnectionDTO connection);
    
    void remove(BusConnectionDTO connection);

    List<BusConnectionDTO> findAll();

    public List<BusConnectionDTO> findConnectionByTime(DateTime departure, DateTime arrival);

    public BusConnectionDTO findConnectionByConcreteFigure(DateTime departure, DateTime arrival, StationDTO departureCity, StationDTO arrivalCity, LineGroupDTO line);
    
    /**
     * 
     * @param range means begin of day and begin of next day
     * @param lg
     * @return
     */
    public List<List<BusConnectionDTO>> findConnectionByTimeRange(TimeRange range, LineGroupDTO lg);

	public void checkAfternoon();

	public void checkMorning();

	List<BusConnectionDTO>findSupportsByTimeRange(DateTime day, Long groupLine);
	
	BusConnectionDTO findFirstEmpty(LineGroupDTO lg);
}
