package cz.sa.shiftPlanner.services;

import java.util.List;

import org.joda.time.DateTime;

import cz.sa.shiftPlanner.dto.ExcuseDTO;
import cz.sa.shiftPlanner.dto.PersonDTO;
import cz.sa.shiftPlanner.dto.PersonRecordDTO;
import cz.sa.shiftPlanner.dto.TimeTrialDTO;
import cz.sa.shiftPlanner.entities.ExcuseVO;
import cz.sa.shiftPlanner.enums.ExcuseReason;
import cz.sa.shiftPlanner.enums.ExcuseStatus;
import cz.sa.shiftPlanner.utils.TimeRange;

/**
 * @author ToSk
 */

public interface PersonUtilsService {

	void createExcuse(ExcuseDTO excuse);
	
	List<ExcuseDTO> findAll();
	
	List<ExcuseDTO> findAllByPersonId(Long id);
	
	Integer sumMonthHours(PersonDTO person, int month, int year);
	
	Long limitMonthHours(PersonDTO person, int month, int year);

	void remove(ExcuseDTO ex);

	void updateExcuse(ExcuseDTO modelObject, ExcuseStatus status);

	List<TimeTrialDTO> findAllByPersonId(long personId, int month, int year);

	void createTrial(TimeTrialDTO tt);

	void updateTrial(TimeTrialDTO tt);

	void remove(TimeTrialDTO modelObject);

	List<TimeTrialDTO> findAllByDay(DateTime day);

	void createTrials(List<TimeRange> ranges, PersonDTO person);
	/**
	 * @param dt - dateTime
	 * if reason is null select all excuses per day {@dt}
	 */
  List<ExcuseDTO> excusesInDay(DateTime dt, ExcuseReason reason);

  void createRecord(PersonRecordDTO record);

  List<PersonRecordDTO> findRecordsByPerson(PersonDTO person);

  void removeRecord(PersonRecordDTO rec);

  void askExcuse(ExcuseDTO ex);

  
}


