package cz.sa.shiftPlanner.services;

import java.util.List;

import cz.sa.shiftPlanner.dto.PersonDTO;
import cz.sa.shiftPlanner.entities.PersonVO;
import cz.sa.shiftPlanner.entities.infrastructure.UserDTO;
import cz.sa.shiftPlanner.utils.ServiceFailureException;



public interface UserService {

	 UserDTO get(String username);

	 UserDTO get(Long id);
	 
	 void create(UserDTO user) throws ServiceFailureException;
	 
	 void remove(UserDTO user);
	 
	 void update(UserDTO user);
	 
	 void updatePassword(UserDTO user, String password);
	 
	 boolean checkPassword(UserDTO user, String password);
	 
	 List<UserDTO> findAll();
	 
	 UserDTO findByPerson(PersonVO p);

	List<UserDTO> findSingIn();
}
