package cz.sa.shiftPlanner.servicesImpl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import cz.sa.shiftPlanner.dto.CityDTO;
import cz.sa.shiftPlanner.dto.PersonDTO;
import cz.sa.shiftPlanner.services.MailService;
import cz.sa.shiftPlanner.services.PersonService;
import cz.sa.shiftPlanner.utils.Mailer;

/**
 *
 * @author    ToSk
 * @version   1.0
 * @created   1. 10. 2013
 */

@Service
@Transactional(propagation = Propagation.REQUIRED)
public class MailServiceImpl implements MailService {

  @Autowired private Mailer mailer;
  @Autowired private PersonService personService;
  
  private static final String MAIL_FROM = "shift-planner@studentagency.cz";
  private static final String MAIL_SUBJECT = "Planovac";

  @Override
  public void sendByCity(CityDTO city, String mailText, PersonDTO loggedPerson) {
    String toEmails = loggedPerson.getEmail();
    for(PersonDTO p : personService.findByDepCity(city)){
      toEmails += ";"+p.getEmail();
    }
    mailer.sendMultiMail(MAIL_FROM, toEmails, MAIL_SUBJECT, mailText, null);
  }

  @Override
  public void sendToAllStew(String mailText, PersonDTO loggedPerson) {
    String toEmails = loggedPerson.getEmail();
    for(PersonDTO p : personService.findAll()){
      toEmails += ";"+p.getEmail();
    }
    mailer.sendMultiMail(MAIL_FROM, toEmails, MAIL_SUBJECT, mailText, null);
  }

  @Override
  public void sendByJobTime(String jobTime, String mailText, PersonDTO loggedPerson) {
    String toEmails = loggedPerson.getEmail();
    for(PersonDTO p : personService.findByHPP(jobTime)){
      toEmails += ";"+p.getEmail();
    }
    mailer.sendMultiMail(MAIL_FROM, toEmails, MAIL_SUBJECT, mailText, null);
  }

  
}
