package cz.sa.shiftPlanner.utils;

import java.util.Arrays;
import java.util.List;

import com.google.common.base.Preconditions;

import cz.sa.shiftPlanner.infrastructure.PropertiesConfigurer;



public class Config extends PropertiesConfigurer {
  

  private List<String> developerLogins;

  public boolean isDevelopment() {
    return "development".equalsIgnoreCase(getProperty("configurationType"));
  }

  public List<String> getDeveloperLogins() {
    if(developerLogins == null) {
      developerLogins = Arrays.asList(getProperty("devel.developerLogins").trim().split("(\\s*,\\s*)|(\\s*;\\s*)"));
    }
    return developerLogins;
  }

  public boolean getBoolean(String propertyKey, boolean defaultValue) {
    String value = getProperty(propertyKey);
    if (value == null) {
      return defaultValue;
    }
    return Boolean.parseBoolean(value.trim());
  }
  
  public int getInt(String propertyKey) {
    String value = getProperty(propertyKey);
    Preconditions.checkNotNull(value);
    return Integer.parseInt(value);
  }
}
