package cz.sa.shiftPlanner.ybus.sync;

import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceContextType;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

/**
 * @author ToSk
 */

@Service
@Transactional(propagation = Propagation.REQUIRES_NEW)
public class YbusSyncPlan implements YbusSyncPlanInterf{

	@Autowired @Qualifier("syncTimecodes") SyncInterface timecodes;
	@Autowired @Qualifier("syncCities") SyncInterface cities;
	@Autowired @Qualifier("syncLineGroups") SyncInterface lineGroups;
	@Autowired @Qualifier("syncTimetables") SyncInterface timetables;
	@Autowired @Qualifier("syncConnections") SyncInterface connections;
	
	private void fillPlanBody(){
  	((SyncTimetable)timetables).getDependent().add(lineGroups);
  	((SyncTimetable)timetables).getDependent().add(cities);
  	((SyncTimetable)timetables).getDependent().add(timecodes);
  	((SyncBusConnections)connections).getDependent().add(timetables);
	}
	
	@Override
	public void runPlan(){
		fillPlanBody();
		connections.start(this);
	}

	@Override
	public void finish(SyncAction action) {
	}

  @Override
  public void run() {
  }

  @Override
  public void start(SyncInterface syncInterface) {
  }
	
}


