package cz.sa.shiftPlanner.pcomponent;

import java.util.Collection;
import java.util.List;

import org.apache.wicket.markup.html.form.CheckBoxMultipleChoice;
import org.apache.wicket.markup.html.form.IChoiceRenderer;
import org.apache.wicket.model.IModel;

/**
 * @author ToSk
 */

public class EnumCheckBoxMultipleChoice<T extends Enum<?>> extends CheckBoxMultipleChoice<T> implements IChoiceRenderer<T> {

	public EnumCheckBoxMultipleChoice(String id) {
		super(id);
		setChoiceRenderer(this);
	}

	public EnumCheckBoxMultipleChoice(final String id, final List<? extends T> choices, final IChoiceRenderer<? super T> renderer) {
		super(id, choices, renderer);
		setChoiceRenderer(this);
	}

	public EnumCheckBoxMultipleChoice(final String id, IModel<? extends Collection<T>> model, final List<? extends T> choices) {
		super(id, model, choices);
		setChoiceRenderer(this);
	}

	public EnumCheckBoxMultipleChoice(final String id, IModel<? extends Collection<T>> model, final List<? extends T> choices, final IChoiceRenderer<? super T> renderer) {
		super(id, model, choices, renderer);
		setChoiceRenderer(this);
	}

	public EnumCheckBoxMultipleChoice(String id, IModel<? extends List<? extends T>> choices) {
		super(id, choices);
		setChoiceRenderer(this);
	}

	public EnumCheckBoxMultipleChoice(String id, IModel<? extends Collection<T>> model, IModel<? extends List<? extends T>> choices) {
		super(id, model, choices);
		setChoiceRenderer(this);
	}

	public EnumCheckBoxMultipleChoice(String id, IModel<? extends List<? extends T>> choices, IChoiceRenderer<? super T> renderer) {
		super(id, choices, renderer);
	}

	public EnumCheckBoxMultipleChoice(String id, IModel<? extends Collection<T>> model, IModel<? extends List<? extends T>> choices, IChoiceRenderer<? super T> renderer) {
		super(id, model, choices, renderer);
		setChoiceRenderer(this);
	}

	public Object getDisplayValue(T object) {
	    return EnumMessageSource.getEnumResourceString(object, getLocale());
	  }

	  public String getIdValue(T object, int index) {
	    return Integer.toString(index);
	  }

}
