package cz.sa.shiftPlanner.pcomponent;

import java.util.Locale;

import javax.annotation.Nullable;

import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.util.ClassUtils;

/**
 * @author ToSk
 */
public final class PMessageSource {

  private ReloadableResourceBundleMessageSource messageSource;

  public PMessageSource(Class<?> clazz) {
    messageSource = new ReloadableResourceBundleMessageSource();
    messageSource.setBasename(ClassUtils.convertClassNameToResourcePath(clazz.getName()));
    messageSource.setFallbackToSystemLocale(false);
  }

  /**
   * Vraci lokalizovanou zpravu pro zadany {@code code}.
   * Pokud zpravu nenajde, vrati {@code code}.
   * 
   * @see #getMessageOrNull()
   */
  public String getMessage(Locale locale, String code, Object... args) {
    return messageSource.getMessage(code, args, code, locale);
  }
  
  /**
   * Vraci lokalizovanou zpravu pro zadany {@code code}.
   * Pokud zpravu nenajde, vrati {@code null}.
   * 
   * @see #getMessage()
   */
  public @Nullable String getMessageOrNull(Locale locale, String code, Object... args) {
    return messageSource.getMessage(code, args, null, locale);
  }

}
