package cz.sa.shiftPlanner.web;

import java.io.Serializable;

import org.apache.log4j.Logger;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.form.AjaxFormComponentUpdatingBehavior;
import org.apache.wicket.authroles.authorization.strategies.role.Roles;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.DropDownChoice;
import org.apache.wicket.markup.html.link.BookmarkablePageLink;
import org.apache.wicket.model.IModel;
import org.apache.wicket.model.Model;
import org.apache.wicket.model.PropertyModel;
import org.apache.wicket.request.mapper.parameter.PageParameters;

import com.google.common.collect.Lists;

import cz.sa.shiftPlanner.web.auth.PlannerSession;

public class HomePage extends AbstractWebPage implements Serializable {
  private static final long serialVersionUID = 1L;
  private static final Logger log = Logger.getLogger(HomePage.class);

  public HomePage(final PageParameters parameters) {
    super(parameters);

    //kontrola na sessionExpired
    if (PlannerSession.get() == null)
      setResponsePage(SignIn.class);
    
    //TODO domyslet validitu (asi se nevyhnu formatu: validita od-do)
//    final IModel<Integer> validityModel = new Model<Integer>(PlannerSession.get().getSelectedYear());
//    DropDownChoice<Integer> validity = new DropDownChoice<Integer>("years", validityModel, Lists.newArrayList(2013, 2014));
//    choice.add(new AjaxFormComponentUpdatingBehavior("onchange") {
//      @Override
//      protected void onUpdate(AjaxRequestTarget target) {
//        PlannerSession.get().setSelectedYear(yearModel.getObject());
//      }
//    });
//    add(choice);
//    choice.setVisible(!PlannerSession.get().getRoles().equals(new Roles()));
    
    final IModel<Integer> yearModel = new Model<Integer>(PlannerSession.get().getSelectedYear());
    DropDownChoice<Integer> choice = new DropDownChoice<Integer>("years", yearModel, Lists.newArrayList(2013, 2014));
    choice.add(new AjaxFormComponentUpdatingBehavior("onchange") {
      @Override
      protected void onUpdate(AjaxRequestTarget target) {
        PlannerSession.get().setSelectedYear(yearModel.getObject());
      }
    });
    add(choice);
    choice.setVisible(!PlannerSession.get().getRoles().equals(new Roles()));

    Label logged = new Label("logged", "Prihlasen jako: ");
    add(logged);
    logged.setVisible(!PlannerSession.get().getRoles().equals(new Roles()));

    Label user = new Label("currentUser", new PropertyModel<String>(this, "session.user"));
    add(user);
    user.setVisible(!PlannerSession.get().getRoles().equals(new Roles()));

    BookmarkablePageLink signOut = new BookmarkablePageLink("signOut", SignOut.class);
    add(signOut);
    signOut.setVisible(!PlannerSession.get().getRoles().equals(new Roles()));

    //        int sessionTimeout = 50;
    //        Request request = RequestCycle.get().getRequest();
    //        if(request instanceof WebRequest) {
    //        	ServletWebRequest wr = (ServletWebRequest) request;
    //        	HttpSession session = wr.getContainerRequest().getSession();
    //        	if(session != null) {
    //        		session.setMaxInactiveInterval(sessionTimeout);
    //        	}
    //        }
  }

}
