package cz.sa.shiftPlanner.web;

import java.util.ArrayList;
import java.util.List;

import org.apache.log4j.Logger;
import org.apache.wicket.AttributeModifier;
import org.apache.wicket.Component;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.form.AjaxFormComponentUpdatingBehavior;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.DropDownChoice;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.link.BookmarkablePageLink;
import org.apache.wicket.markup.html.list.AbstractItem;
import org.apache.wicket.markup.repeater.Item;
import org.apache.wicket.markup.repeater.data.DataView;
import org.apache.wicket.markup.repeater.data.ListDataProvider;
import org.apache.wicket.model.Model;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.apache.wicket.spring.injection.annot.SpringBean;

import cz.sa.shiftPlanner.dto.PersonDTO;
import cz.sa.shiftPlanner.services.PersonService;

public class PersonViewPage extends MenuPage {

	@SpringBean(name = "personService")
	PersonService personService;

	private static final Logger log = Logger.getLogger(PersonViewPage.class);
	private DropDownChoice<String> combo; 
	
	public PersonViewPage(PageParameters parameters) {
		super(parameters);
		showAll();
	}

	private void showAll(){
		
		add(new Label("message", "Stevardi"));
		
		Component header = new AbstractItem("header");
		add(header);
		ListDataProvider<PersonDTO> dp = new ListDataProvider<PersonDTO>(personService.findAll());
		
		final DataView<PersonDTO> dataView = new DataView<PersonDTO>("repeating", dp)
		    {
		  private static final long serialVersionUID = 1L;
		  
		  @Override
		  protected void populateItem(final Item<PersonDTO> item)
		  {
		    item.add(new Label("personalNumber", String.valueOf(item.getModelObject().getPersonalNumber())));
		    item.add(new Label("name", item.getModelObject()));
		    item.add(new Label("weekWorkTime", String.valueOf(item.getModelObject().getWeekWorkTime())));
		    item.add(new Label("class", String.valueOf(item.getModelObject().getClassification())));
		    item.add(new Label("mail", String.valueOf(item.getModelObject().getEmail())));
		    
		    final PageParameters pageParameters = new PageParameters();
		    pageParameters.add("perId", String.valueOf(item.getModelObject().getId()));
		    item.add(new BookmarkablePageLink("edit", PersonDetailPage.class, pageParameters));
		    
		    item.add(new AttributeModifier("class", (item.getIndex() % 2 == 1) ? "even" : "odd"));
		  }
		    };
		    add(dataView);

	}

	private void renderSlect() {
	  Form<Void> f = new Form<Void>("form"); 
    add(f); 

    List<String> choices = new ArrayList<String>(); 
    choices.add("1"); 
    choices.add("2"); 
    choices.add("3"); 
    choices.add("4"); 

    combo = new DropDownChoice<String>("combo", new Model<String>(""), choices); 
    combo.setOutputMarkupId(true); 
    combo.setNullValid(false); 
    combo.setRequired(false); 
    combo.add(new AjaxFormComponentUpdatingBehavior("onchange") { 
            private static final long serialVersionUID = 8796893689873687205L; 

            @Override 
            protected void onUpdate(AjaxRequestTarget target) { 
                    String s = combo.getRawInput(); 
                    target.appendJavaScript("alert('" + s + "')"); 
            } 
            

    }); 
    f.add(combo); 
  }

}
