package cz.sa.shiftPlanner.web;

import javax.jws.HandlerChain;

import org.apache.wicket.Session;
import org.apache.wicket.authroles.authentication.AuthenticatedWebSession;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.PasswordTextField;
import org.apache.wicket.markup.html.form.RequiredTextField;
import org.apache.wicket.markup.html.form.StatelessForm;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.model.CompoundPropertyModel;
import org.apache.wicket.protocol.https.RequireHttps;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.apache.wicket.spring.injection.annot.SpringBean;

import cz.sa.shiftPlanner.services.UserService;


/**
 *
 * @author ToSk
 */

@RequireHttps
public class SignIn extends HomePage {

	@SpringBean(name = "userService")
    private UserService service;
	
    public SignIn(PageParameters parameters) {
        super(parameters);
        final LoginForm form = new LoginForm("loginForm");
        add(form);
        
    }

    private class LoginForm extends StatelessForm {

        private String username;
        private String password;

        public LoginForm(String id) {
            super(id);
            setModel(new CompoundPropertyModel(this));
            add(new Label("usernameLabel", "Osobni cislo"));
            RequiredTextField userName = new RequiredTextField("username");
            add(userName);

            add(new Label("passwordLabel", "Heslo"));
            PasswordTextField password = new PasswordTextField("password");
            add(password);
            add(new FeedbackPanel("feedback"));

        }

        @Override
        protected void onSubmit() {
            AuthenticatedWebSession session = (AuthenticatedWebSession) Session.get();
        	
            if (session.signIn(username, password)) {
                setResponsePage(LineGroupViewPage.class);
            } else {
                //error(getString("login failed"));
            	error("Spatne jmeno nebo heslo");
            }
        }
    }
    
    
}
