package cz.sa.shiftPlanner.web.notification;

import java.util.ArrayList;
import java.util.List;

import org.apache.wicket.PageReference;
import org.apache.wicket.ajax.AjaxRequestTarget;
import org.apache.wicket.ajax.markup.html.form.AjaxButton;
import org.apache.wicket.extensions.ajax.markup.html.modal.ModalWindow;
import org.apache.wicket.extensions.ajax.markup.html.tabs.AjaxTabbedPanel;
import org.apache.wicket.extensions.markup.html.tabs.AbstractTab;
import org.apache.wicket.extensions.markup.html.tabs.ITab;
import org.apache.wicket.markup.html.WebMarkupContainer;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.panel.Panel;
import org.apache.wicket.model.Model;
import org.apache.wicket.request.mapper.parameter.PageParameters;

import cz.sa.shiftPlanner.enums.NotifType;
import cz.sa.shiftPlanner.web.AbstractWebPage;

/**
 * ToSk
 */

public class NotificationModalWindow extends AbstractWebPage {

  List<ITab> tabs = new ArrayList<ITab>();

  public NotificationModalWindow(final PageReference modalWindowPage, final ModalWindow window, PageParameters param) {
    super(param);

    WebMarkupContainer container = new WebMarkupContainer("content");

    tabs.add(new AbstractTab(new Model<String>("Neobsazene spoje")) {
      public Panel getPanel(String panelId) {
        return new EmptyWayPanel(panelId);
      }
    });
    for (final NotifType type : NotifType.values()) {
      tabs.add(new AbstractTab(new Model<String>(type.toString())) {
        public Panel getPanel(String panelId) {
          return new NotificationContentPanel(panelId,type);
        }
      });
    }
    tabs.add(new AbstractTab(new Model<String>("Kdo je Online")) {
      public Panel getPanel(String panelId) {
        return new WhoIsOnlinePanel(panelId);
      }
    });

    Form buttonForm = new Form("buttonForm");
    // Add a cancel / close button.
    buttonForm.add(new AjaxButton("close") {
      public void onSubmit(AjaxRequestTarget target, Form form) {
        window.close(target);
      }
    });
    container.add(new AjaxTabbedPanel("tabs", tabs), buttonForm);
    add(container);

  }

}
